# TSGM: Time-series Generation using Score-based Generative Models

### We give two representive data : stock, energy, and their codes. For other datasets, you can easily get them from link in our paper by removing miscellaneous data, as described in our paper.
### If you want to experience with other data, you have to modify conditional score network appropriately, by changing normalization parts in ./models/conditional_ncsnpp.py. compare with energy.
### We use python=3.9.x

## Requirements

```
pip install -r requirements.txt
```

## Experimental Commands

### Regular Stock - VP

```
cd regular
cd stock
python main.py --mode 'train' --model 'vp'
python main.py --mode 'evaluate' --model 'vp'
```

### Regular Stock - subVP

```
cd regular
cd stock
python main.py --mode 'train' --model 'subvp'
python main.py --mode 'evaluate' --model 'subvp'
```

### Regular Energy - VP

```
cd regular
cd energy
python main.py --mode 'train_ER' --model 'vp'
python main.py --mode 'train_conditional_score' --model 'vp'
python main.py --mode 'cal_score' --model 'vp'
```

### Regular Energy - subVP

```
cd regular
cd energy
python main.py --mode 'train_ER' --model 'subvp'
python main.py --mode 'train_conditional_score' --model 'subvp'
python main.py --mode 'cal_score' --model 'subvp'
```

### Irregular Stock with 30% missing rate - VP

```
cd irregular
python stocks_irregular.py --str_sde 'vp' --train True --missing_value 0.3
python stocks_irregular.py --str_sde 'vp' --train False --missing_value 0.3
```

### Irregular Stock with 30% missing rate - subVP

```
cd irregular 
python stocks_irregular.py --str_sde 'subvp' --train True --missing_value 0.3
python stocks_irregular.py --str_sde 'subvp' --train False --missing_value 0.3
```

### Irregular Energy with 30% missing rate - VP

```
cd irregular
python energy_irregular.py --str_sde 'vp' --train True --missing_value 0.3
python energy_irregular.py --str_sde 'vp' --train False --missing_value 0.3
```

### Irregular Energy with 30% missing rate - subVP

```
cd irregular
python energy_irregular.py --str_sde 'subvp' --train True --missing_value 0.3
python energy_irregular.py --str_sde 'subvp' --train False --missing_value 0.3
```