import numpy as np
import torch
import os
from predictive_metrics import predictive_score_metrics
from discriminative_metrics import discriminative_score_metrics
from visualization_metrics import visualization
import tensorflow as tf

def cal_score(args, x, x_hat, dataset_size):
    generated_data_curr = x.cpu().numpy()
    generated_data1 = list()
    for i in range(dataset_size):
        temp = generated_data_curr[i, :, :]
        generated_data1.append(temp)

    generated_data_curr = x_hat.cpu().numpy()
    args.sample_dir = f'./samples_{args.data}'
    os.makedirs(args.sample_dir, exist_ok=True)
    np.save(f'{args.sample_dir}/save_{args.missing_value}', generated_data_curr)
    generated_data2 = list()
    for i in range(dataset_size):
        temp = generated_data_curr[i, :, :]
        generated_data2.append(temp)
    visualization(generated_data1, generated_data2,"tsne",args)

    metric_results = dict()
    tf.compat.v1.disable_eager_execution()

    predictive_score = list()
    for tt in range(args.max_steps_metric):
        temp_pred = predictive_score_metrics(generated_data1, generated_data2)
        predictive_score.append(temp_pred)

    metric_results['predictive'] = np.mean(predictive_score)
    metric_results['predictive_std'] = np.std(predictive_score)

    discriminative_score = list()
    for _ in range(args.max_steps_metric):
        temp_disc = discriminative_score_metrics(generated_data1, generated_data2)
        discriminative_score.append(temp_disc)

    metric_results['discriminative'] = np.mean(discriminative_score)
    metric_results['discriminative_std'] = np.std(discriminative_score)
    return metric_results
